/*
** Module   : XCommonImpl
** Abstract : SAX attributes, reader, writer common fatures iplementation.
**
** Copyright (c) 2013, Golden Code Development Corporation.
** ALL RIGHTS RESERVED. Use is subject to license terms.
**
**           Golden Code Development Corporation
**                      CONFIDENTIAL
**
** -#- -I- --Date-- ---------------------------------Description----------------------------------
** 001 EVL 20130214 Created initial version. Implementation is limited to the stubs to get the
**                  converted java code compiled.
*/

package com.goldencode.p2j.xml;

import com.goldencode.p2j.util.*;

/**
 * Implementation the common features for XML related Progress objects.
 */
public class XCommonImpl
implements XCommon
{
   // Attributes
   /**
    * Gets the value of the XML schema file for elements with no namespaces.  
    *
    * @return   The value of the nonamespace-schema-location attribute.
    */
   public character getNonamespaceSchemaLocation()
   {
      return new character();
   }
   
   /**
    * Setting the new value for the nonamespace-schema-location attribute.
    * 
    * @param    nonamespaceSchemaLocation
    *           New value of the nonamespace-schema-location attribute to set.
    */
   public void setNonamespaceSchemaLocation(character nonamespaceSchemaLocation)
   {
      // TODO:
      return;
   }
   
   /**
    * Setting the new value for the nonamespace-schema-location attribute.
    * 
    * @param    nonamespaceSchemaLocation
    *           New value of the nonamespace-schema-location attribute to set.
    */
   public void setNonamespaceSchemaLocation(String nonamespaceSchemaLocation)
   {
      setNonamespaceSchemaLocation(new character(nonamespaceSchemaLocation));
   }
   
   // Methods
   /**
    * Reports if this object is valid for use.  
    *
    * @return   <code>true</code> if we are valid (can be used).
    */
   public boolean isValid()
   {
      // TODO:
      return true;
   }
   
   /**
    * Reports if this object is unknown.  
    *
    * @return   <code>true</code> if object is unknown.
    */
   public boolean isUnknown()
   {
      // TODO:
      return true;
   }

   /**
    * Adding new match pair for namespace schema and physical file location.
    * 
    * @param    targetNamespace
    *           Target namespace of the schema or am empty string or Unknown value.
    * @param    location
    *           Location of the XML schema file.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical addSchemaLocation(String targetNamespace, character location)
   {
      return addSchemaLocation(new character(targetNamespace), location);
   }

   /**
    * Adding new match pair for namespace schema and physical file location.
    * 
    * @param    targetNamespace
    *           Target namespace of the schema or am empty string or Unknown value.
    * @param    location
    *           Location of the XML schema file.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical addSchemaLocation(character targetNamespace, String location)
   {
      return addSchemaLocation(targetNamespace, new character(location));
   }

   /**
    * Adding new match pair for namespace schema and physical file location.
    * 
    * @param    targetNamespace
    *           Target namespace of the schema or am empty string or Unknown value.
    * @param    location
    *           Location of the XML schema file.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical addSchemaLocation(String targetNamespace, String location)
   {
      return addSchemaLocation(new character(targetNamespace), new character(location));
   }

   /**
    * Adding new match pair for namespace schema and physical file location.
    * 
    * @param    targetNamespace
    *           Target namespace of the schema or am empty string or Unknown value.
    * @param    location
    *           Location of the XML schema file.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical addSchemaLocation(character targetNamespace, character location)
   {
      // TODO:
      return new logical(true);
   }
   
   /**
    * Removes the specified attribute.
    * 
    * @param    attrName
    *           The name of the attribute to remove.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical removeAttribute(character attrName)
   {
      return removeAttribute(attrName, new character());
   }
   
   /**
    * Removes the specified attribute.
    * 
    * @param    attrName
    *           The name of the attribute to remove.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical removeAttribute(String attrName)
   {
      return removeAttribute(new character(attrName), new character());
   }
   
   /**
    * Removes the specified attribute.
    * 
    * @param    index
    *           The 1-based index of the attribute to remove.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical removeAttribute(integer index)
   {
      return removeAttribute(index, new character());
   }
   
   /**
    * Removes the specified attribute.
    * 
    * @param    index
    *           The 1-based index of the attribute to remove.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical removeAttribute(int index)
   {
      return removeAttribute(new integer(index), new character());
   }

   /**
    * Removes the specified attribute.
    * 
    * @param    attrName
    *           The name of the attribute to remove.
    * @param    namespaceUri
    *           The URI of the attribute to remove.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical removeAttribute(character attrName, character namespaceUri)
   {
      // TODO:
      return new logical(true);
   }
   
   /**
    * Removes the specified attribute.
    * 
    * @param    attrName
    *           The name of the attribute to remove.
    * @param    namespaceUri
    *           The URI of the attribute to remove.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical removeAttribute(String attrName, character namespaceUri)
   {
      return removeAttribute(new character(attrName), namespaceUri);
   }
   
   /**
    * Removes the specified attribute.
    * 
    * @param    index
    *           The 1-based index of the attribute to remove.
    * @param    namespaceUri
    *           The URI of the attribute to remove.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical removeAttribute(integer index, character namespaceUri)
   {
      // TODO:
      return new logical(true);
   }
   
   /**
    * Removes the specified attribute.
    * 
    * @param    index
    *           The 1-based index of the attribute to remove.
    * @param    namespaceUri
    *           The URI of the attribute to remove.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical removeAttribute(int index, character namespaceUri)
   {
      return removeAttribute(new integer(index), namespaceUri);
   }

   /**
    * Removes the specified attribute.
    * 
    * @param    attrName
    *           The name of the attribute to remove.
    * @param    namespaceUri
    *           The URI of the attribute to remove.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical removeAttribute(character attrName, String namespaceUri)
   {
      return removeAttribute(attrName, new character(namespaceUri));
   }
   
   /**
    * Removes the specified attribute.
    * 
    * @param    attrName
    *           The name of the attribute to remove.
    * @param    namespaceUri
    *           The URI of the attribute to remove.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical removeAttribute(String attrName, String namespaceUri)
   {
      return removeAttribute(new character(attrName), new character(namespaceUri));
   }
   
   /**
    * Removes the specified attribute.
    * 
    * @param    index
    *           The 1-based index of the attribute to remove.
    * @param    namespaceUri
    *           The URI of the attribute to remove.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical removeAttribute(int index, String namespaceUri)
   {
      return removeAttribute(new integer(index), new character(namespaceUri));
   }
   
   /**
    * Removes the specified attribute.
    * 
    * @param    index
    *           The 1-based index of the attribute to remove.
    * @param    namespaceUri
    *           The URI of the attribute to remove.
    * 
    * @return   The <code>true</code> in case of success <code>false</code> otherwise.
    */
   public logical removeAttribute(integer index, String namespaceUri)
   {
      return removeAttribute(index, new character(namespaceUri));
   }
}
